<?Php
session_start();
$tracking_page_name="JQ_password-validation";
echo "<meta http-equiv=\"Content-Type\" content=\"text/html; charset=windows-1252\">
<html>
<head>
<title>Password validation using JQuery bootstrap for minimum requirement </title>
<META NAME=\"DESCRIPTION\" CONTENT=\"Validating user entered data as password for different conditions using Jquery\">
<META NAME=\"KEYWORDS\" CONTENT=\"password validation, jquery, data validation, jquery validation, data and password \">

";
require "../templates/head.php";
echo "</head><body>";
$img_path="..";
$top_links="";
require "templates/top3.php";  
echo "<div id='body_content' itemscope itemtype=\"http://schema.org/TechArticle\"><table><tr><td>
<h1 itemprop=\"headline\">Password validation using JQuery </h1>";
require "templates/body_start.php";  
?>
We often ask users to enter password with some minimum requirement. While entering the text in password field we can check and display help messages to guide user. 
<br><br>
Here we will learn how to validate user entered text and display message asking user to use correct combination of text as password. 

<div class="panel panel-danger">Note that validating at client side by using JavaScript or JQuery is not a foolproof method so after submitting the data, server side validation is to be done to check the inputs. However client side validation helps user in understanding what is required before submitting the details to server side. This helps in better user experience. </div>

<nav>
  <ul class='pager'>
    <li><a href='../php_tutorial/string-checking.php'>Server side validation using PHP <span aria-hidden='true'>&rarr;</span></a></li>
  </ul>
</nav>

We can display one  password input box and by the side of it we will display a layer of help text (&lt;span id="d1" class="tool_tip"&gt;). Inside this layer we will have four lines of text span with individual ID for control based on the input condition. 
<pre><code>&lt;input type=password name=my_text id=t1&gt;

 &lt;span id="d1" class="tool_tip"&gt;
&lt;span id=d12&gt;One Upper case letter&lt;/span&gt;&lt;br&gt;
&lt;span id=d13&gt;One Lower case letter&lt;/span&gt;&lt;br&gt;
&lt;span id=d14&gt;One Special char&lt;/span&gt;&lt;br&gt;
&lt;span id=d15&gt;One number&lt;/span&gt;&lt;br&gt;
&lt;span id=d16&gt;Length 8  char&lt;/span&gt;

&lt;/span&gt;&lt;br&gt;&lt;div id=display_box class=msg&gt;&lt;/div&gt;</code></pre>

We manage the display of this layer by using style declared inside head section of the page. 
<br><br>
By default we kept this layer as hidden from the user (check the Style property of <i>tool_tip</i> class) and it only appears once user click or enters into the password box. At the same time we hide this box once it loses focus (user moves out of the password filed)  . This is managed by JQuery 

<pre><code>$('#t1').blur(function(){
$("#d1").fadeOut();
});
///////////
$('#t1').focus(function(){
$("#d1").show();
$('#d12,#d13,#d14,#d15,#d16').css("color", "black");
});</code></pre>

Every time user enters or delete any char inside the password field, we will check the total string for validation and display the matching text helping user to understand the requirement. 

For this we will use <a href=event-keyup.php>keyup event</a> to trigger the checking of the string. 

<h2>Requirements of Validation</h2>
The entered password string will be checked for following points. 
<ul class="list-group">
<li class="list-group-item">User must enter at least one lower case letter </li>
<li class="list-group-item">User must enter one upper case letter </li>
<li class="list-group-item">User must enter one special character </li>
<li class="list-group-item">User must enter one number </li>
<li class="list-group-item">Total length must be minimum 8 character </li>
</ul>
We will keep one Flag which state we will change from <i>T</i> to <i>F</i> if any validation fails
<br><br>
We will use regular expression to check the string. We will prepare variable for this and then match with the string entered by the user.   

. <pre><code>var upper_text= new RegExp('[A-Z]');
var lower_text= new RegExp('[a-z]');
var number_check=new RegExp('[0-9]');
var special_char= new RegExp('[!/\'^$%&*()}{@#~?&gt;&lt;&gt;,|=_+-\]');
</code></pre>
<h2>Validating for lower case letters</h2>
Our requirement is user must enter at least one lower case character. So we will check by using one if condition and if it returns true then we will apply CSS to change the background color to show that this condition is adhered. 
<pre><code>if(str.match(lower_text)){
$('#d13').css("background-color", "green");
}else{$('#d13').css("background-color", "red");
flag='F';}
</code></pre>


For failure of validation we are setting the Flag condition to false or F. 
<br><br>
Same way you can verify the other conditions like presence of one upper case letter, one special character, one number and total length of the string should be minimum 8. 
<br><br>
Once all the validations are cleared then our flag will have true value or T. Based on this we will decide to display the help text or not. Since password field chars are masked we are also displaying the user entered text in another div layer to show to the user. This need not be done in a practical script.


<h2>Demo of validation script</h2>
We have two demos in which basic script remains same. Second one is including bootstrap design. If you are not aware of bootstrap design then better to download or check default validation script. Using default validation script you can add your own design to it. 
 
<nav>
  <ul class='pager'>
    <li><a href='password-validation-demo.php'>Demo of default validation script <span aria-hidden='true'>&rarr;</span></a></li>
  </ul>
</nav>

      
<nav>
  <ul class='pager'>
    <li><a href='msg-demo/password-validation.php'>Demo of validation script using bootstrap design <span aria-hidden='true'>&rarr;</span></a></li>
  </ul>
</nav>
<a href='password-validation.zip' target=new><button type="button" class="btn btn-info">Download default validation script <span class="glyphicon glyphicon-download-alt" aria-hidden="true"></span> </button></a>

<?Php
require "../include/z_db1.php";
require "templates/body_end.php";
require "../common-tags3.php";
require "templates/ads.php";
echo"</td></tr><tr><td>";
require "link-basic.php";
///#starting-cmt-display#////
require "../cmt-display.php";
///#ending-cmt-display#////
echo "</td></tr><tr><td>";
require "../cmt-ajax-form.php";

echo "</td></tr></table></div> ";

require "templates/side3.php";
require "templates/bottom4.php";
?>
</body>
</html>